<!DOCTYPE html>
<html lang="en">

<head>
    <title>Users CRUD</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- Vùng header-->
    <div class="container">
        <div class="text-center mt-3">
            <h2>F120 - Quản trị Users</h2>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; New User</button>
        </div>
    </div>
    <!--User Data Table-->
    <div class="container">
        <table class="table table-bordered table-striped table-hover" id="user-table">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
    <!--Vùng Modal-->

    <!--Create User modal-->
    <div>
        <div id="create-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Create new user</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-firstname">Firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-firstname" name="firstname"
                                        placeholder="Firstname" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-lastname">Lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-lastname" name="lastname" placeholder="Lastname"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-create-country" class="col-form-label col-sm-4">Country</label>
                                <div class="col-sm-8">
                                    <select id="select-create-country" class="form-control">
                                        <option value="VN">Vietnam</option>
                                        <option value="AUS">Australia</option>
                                        <option value="USA">USA</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-create-customer-type" class="col-form-lable col-sm-4">Customer
                                    Type</label>
                                <div class="col-sm-8">
                                    <select id="select-create-customer-type" class="form-control">
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premimum</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-create-subject">Subject</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-subject" name="subject" placeholder="Subject"
                                        class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-primary" id="btn-create-user">Insert User</button>
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!--Update User modal-->
    <div>
        <div id="update-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Chi tiết User</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-firstname">Firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-firstname" name="firstname"
                                        placeholder="Firstname" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-lastname">Lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-lastname" name="lastname" placeholder="Lastname"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-update-country" class="col-form-label col-sm-4">Country</label>
                                <div class="col-sm-8">
                                    <select id="select-update-country" class="form-control">
                                        <option value="VN">Vietnam</option>
                                        <option value="AUS">Australia</option>
                                        <option value="USA">USA</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-update-customer-type" class="col-form-lable col-sm-4">Customer
                                    Type</label>
                                <div class="col-sm-8">
                                    <select id="select-update-customer-type" class="form-control">
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premimum</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-update-register-status" class="col-form-lable col-sm-4">Register
                                    Status</label>
                                <div class="col-sm-8">
                                    <select id="select-update-register-status" class="form-control">
                                        <option value="New">New</option>
                                        <option value="Accepted">Accepted</option>
                                        <option value="Denied">Denied</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-subject">Subject</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-subject" name="subject" placeholder="Subject"
                                        class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-primary" id="btn-update-user">Update User</button>
                        <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Bạn có chắc chắn muốn xóa user này không?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
                        <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global Variables */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    //Biến toàn cục để lưu trữ id user đang được update or delete. Mặc định = 0;
    var gUserId = 0;

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];

    //Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gUSER_ID_COL = 0;
    const gUSER_FISTNAME_COL = 1;
    const gUSER_LASTNAME_COL = 2;
    const gUSER_COUNTRY_COL = 3;
    const gUSER_SUBJECT_COL = 4;
    const gUSER_CUSTOMER_TYPE_COL = 5;
    const gUSER_REGISTER_STATUS_COL = 6;
    const gUSER_ACTION_COL = 7;

    // Khai báo DataTable & Mapping column
    var gUserTable = $("#user-table").DataTable({
        columns: [
            { data: gUSER_COLS[gUSER_ID_COL] },
            { data: gUSER_COLS[gUSER_FISTNAME_COL] },
            { data: gUSER_COLS[gUSER_LASTNAME_COL] },
            { data: gUSER_COLS[gUSER_COUNTRY_COL] },
            { data: gUSER_COLS[gUSER_SUBJECT_COL] },
            { data: gUSER_COLS[gUSER_CUSTOMER_TYPE_COL] },
            { data: gUSER_COLS[gUSER_REGISTER_STATUS_COL] },
            { data: gUSER_COLS[gUSER_ACTION_COL] }
        ],
        columnDefs: [
            { // định nghĩa các cột action
                targets: gUSER_ACTION_COL,
                defaultContent: `
                    <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `
            }
        ]
    });
    /*** REGION 2 - Vùng gán/  thực thi sự kiện cho các element */
    $(document).ready(function () {
        onPageLoading();
    });
    // gán sự kiện Create - them 1 user
    $("#btn-add-user").on("click", function () {
        onBtnAddNewUserClick();
    });
    // gán sự kiện Update - sửa 1 user
    $("#user-table").on("click", ".edit-user", function () {
        onBtnEditUserClick(this);
    });
    // gán sự kiện Delete - xoa 1 user
    $("#user-table").on("click", ".delete-user", function () {
        onBtnDeleteUserClick(this);
    });

    // gán sự kiện Inser User - them 1 user tren modal
    $("#btn-create-user").on("click", function () {
        onBtnCreateUserClick();
    });

    // gán sự kiện cho nút Update User (trên modal)
    $("#btn-update-user").on("click", function () {
        onBtnUpdateUserClick();
    });

    // gán sự kiện cho nút Confirm Delete User (trên modal)
    $("#btn-confirm-delete-user").on("click", function () {
        onBtnConfirmDeleteUserClick();
    });

    /*** REGION 3 - Event handlers */
    function onPageLoading() {
        //B1: Thu thap du lieu
        getAllUsers();
    }
    // Hàm xử lý sự kiện khi New User được click
    function onBtnAddNewUserClick() {
        //hiển thị modal trắng lên
        $("#create-user-modal").modal("show");
    }
    // Hàm xử lý sự kiện khi Insert User được click
    function onBtnCreateUserClick() {
        //khai báo đối tượng chứa user data
        var vObjectRequestData = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: ""
        };
        //B1: thu thap du lieu
        getInsertUserData(vObjectRequestData);
        //B2: Validate Insert
        var vIsValidate = validateUserData(vObjectRequestData);
        //ghi ra console giá trị trả ra của hàm validateUserData
        console.log(vIsValidate);
        //B3: Insert User
        $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(vObjectRequestData),
            success: function (paramRes) {
                //Ghi response ra console
                console.log(paramRes);
                //B4: front-end 
                handleInsertUserSuccess();
            },
            error: function (paramErr) {
                console.log(paramErr.status)
            }
        });
    }
    // Hàm xử lý sự kiện khi icon edit user trên bảng được click
    function onBtnEditUserClick(paramBtnEdit) {
        //lưu thông tin userId đang được edit vào biến toàn cục
        gUserId = getUserIdFromButton(paramBtnEdit);
        console.log("Id = " + gUserId);
        //hiển thị modal trắng lên
        $("#update-user-modal").modal("show");
        // load dữ liệu vào các trường dữ liệu trong modal
        getUserById(gUserId);
    }
    // hàm xử lý sự kiện update user modal click
    function onBtnUpdateUserClick() {
        // khai báo đối tượng chứa user data
        var vUserObj = {
            firstname: "",
            lastname: "",
            country: "",
            subject: "",
            customerType: "",
            registerStatus: "",
        };
        // B1: Thu thập dữ liệu
        getUpdateUserData(vUserObj);
        // B2: Validate update
        var vIsUserValidate = validateUserData(vUserObj);
        if (vIsUserValidate) {
            // B3: update user
            $.ajax({
                url: gBASE_URL + gUserId,
                type: "PUT",
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vUserObj),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleUpdateUserSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
        }
    }

    // Hàm xử lý sự kiện khi icon delete user trên bảng được click
    function onBtnDeleteUserClick(paramBtnDelete) {
        //lưu thông tin userId đang được xoa vào biến toàn cục
        gUserId = getUserIdFromButton(paramBtnDelete);
        console.log("Id = " + gUserId);
        // hiển thị modal confirm delete lên
        $("#delete-confirm-modal").modal("show");
    }
    // // Hàm xử lý sự kiện khi nút confirm delete user trên modal được click
    function onBtnConfirmDeleteUserClick() {
        $.ajax({
                url: gBASE_URL + gUserId,
                type: "DELETE",
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleDeleteUserSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
    }
    /*** REGION 4 - Common Functions */
    /** load users to Datatable
     * in: users array
     * out: user table has data
     */
    function loadDataToUserTable(paramUsers) {
        gUserTable.clear();
        gUserTable.rows.add(paramUsers);
        gUserTable.draw();
    }
    //hàm gọi api để lấy danh sách all user đăng ký
    function getAllUsers() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function (paramUsers) {
                // Ghi Response ra console
                console.log(paramUsers);
                loadDataToUserTable(paramUsers);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }
    // hàm get user by id
    function getUserById(paramUserId) {
        $.ajax({
            url: gBASE_URL + paramUserId,
            type: "GET",
            success: function (paramUser) {
                showUserDataToModal(paramUser);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }

    // hàm show user obj lên modal
    function showUserDataToModal(paramUser) {
        $("#input-update-firstname").val(paramUser.firstname);
        $("#input-update-lastname").val(paramUser.lastname);
        $("#select-update-country").val(paramUser.country);
        $("#input-update-subject").val(paramUser.subject);
        $("#select-update-customerType").val(paramUser.customerType);
        $("#select-update-register-status").val(paramUser.registerStatus);
    }

    // hàm dựa vào button detail (edit or delete) xác định được id user
    function getUserIdFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vUserRowData = gUserTable.row(vTableRow).data();
        return vUserRowData.id;
    }

    //hàm thu thâpj dữ liệu để create user
    function getInsertUserData(paramUserObj) {
        paramUserObj.firstname = $("#input-create-firstname").val().trim();
        paramUserObj.lastname = $("#input-create-lastname").val().trim();
        paramUserObj.country = $("#select-create-country").val();
        paramUserObj.subject = $("#input-create-subject").val().trim();
        paramUserObj.customerType = $("#select-create-customerType").val();
    }

    // hàm validate data
    function validateUserData(paramUserObj) {
        if (paramUserObj.firstname === "") {
            alert("Enter firstname!");
            return false;
        }

        if (paramUserObj.lastname === "") {
            alert("Enter lastname!");
            return false;
        }

        if (paramUserObj.subject === "") {
            alert("Enter Subject!");
            return false;
        }
        return true;
    }

    // xử lý front-end khi thêm user thành công
    //Khi người dùng ấn OK trên cửa sổ thông báo Alert: xóa trắng dữ liệu trên modal, tắt Modal đi và load lại bảng danh sách users
    function handleInsertUserSuccess() {
        alert("Add user successful!");
        getAllUsers();
        resertCreateUserForm();
        $("#create-user-modal").modal("hide");
    }

    //hàm xóa trắng form create user
    function resertCreateUserForm() {
        $("#input-create-firstname").val("");
        $("#input-create-lastname").val("");
        $("#select-create-country").val("VN");
        $("#select-create-customerType").val("Standard");
        $("#input-create-subject").val("");
    }

    // hàm thu thập dữ liệu để update user
    function getUpdateUserData(paramUserObj) {
        paramUserObj.firstname = $("#input-update-firstname").val().trim();
        paramUserObj.lastname = $("#input-update-lastname").val().trim();
        paramUserObj.country = $("#select-update-country").val();
        paramUserObj.subject = $("#input-update-subject").val().trim();
        paramUserObj.customerType = $("#select-update-customerType").val();
        paramUserObj.customerType = $("#select-update-register-status").val();
    }

    // hàm xử lý hiển thị front-end khi sửa user thành công
    function handleUpdateUserSuccess() {
        alert("Sửa user thành công!");
        getAllUsers();
        resertUpdateUserForm();
        $("#update-user-modal").modal("hide");
    }

    // hàm xóa trắng form update user
    function resertUpdateUserForm() {
        $("#input-update-firstname").val("");
        $("#input-update-lastname").val("");
        $("#select-update-country").val("VN");
        $("#select-update-customerType").val("Standard");
        $("#input-update-subject").val("");
        $("#select-update-register-status").val("Accepted");
    }

     // hàm xử lý hiển thị front-end khi sửa user thành công
     function handleDeleteUserSuccess() {
        alert("Delete user thành công!");
        getAllUsers();
        $("#delete-user-modal").modal("hide");
    }
</script>

</html>